app/file/forms.py
# -*- coding: utf-8 -*-
"""
Copyright 2015 Soeren Mindorf <support@mit42.de> and Fabian Zoske <support@zoske.it>

This file is part of Download-Link.

Download-Link is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

Download-Link is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Download-Link. If not, see <http://www.gnu.org/licenses/>.
"""

from flask.ext.babel import lazy_gettext
from flask.ext.wtf import Form
from wtforms import StringField, SubmitField, IntegerField, HiddenField
from flask_wtf.file import FileField
from wtforms.validators import Length, number_range, DataRequired


class UploadForm(Form):
    filename = FileField(lazy_gettext(u'Upload file:'))
    download_name = StringField(lazy_gettext(u'Filename to download:'), [Length(max=50)])
    note = StringField(lazy_gettext(u'Note:'), [Length(max=255)])
    lifetime = IntegerField(lazy_gettext(u'Lifetime (in days):'), default=60)
    submit = SubmitField(lazy_gettext(u'Upload'))


class GenerateUid(Form):
    max_downloads = IntegerField(lazy_gettext(u'Enter maximal count of Downloads:'),
                                 [number_range(min=1, max=99), DataRequired()])
    genuniqueids = IntegerField(lazy_gettext(u'How many Downloadkeys should be generated (1-40)?'),
                                [number_range(min=1, max=40),
                                 DataRequired()])
    lifetime = IntegerField(lazy_gettext(u'How long should the Download be valid (in days)? '
                                         u'(default=10, Max: 90 days)'), default=10)
    file_id = HiddenField(id='file_id')
    submit = SubmitField(lazy_gettext(u'generate uniqueids'))


class FileEditForm(Form):
    downloadName = StringField(lazy_gettext(u'Filename to download'), [Length(max=50)])
    note = StringField(lazy_gettext(u'Note'), [Length(max=255)])
    lifetime = IntegerField(lazy_gettext(u'Lifetime (in days)'), default=120)
    submit = SubmitField(lazy_gettext(u'Update'))

app/file/__init__.py
"""
Copyright 2015 Soeren Mindorf <support@mit42.de> and Fabian Zoske <support@zoske.it>

This file is part of Download-Link.

Download-Link is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

Download-Link is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Download-Link. If not, see <http://www.gnu.org/licenses/>.
"""

from flask import Blueprint

file = Blueprint('file', __name__)

from . import views

app/file/views.py
# -*- coding: utf-8 -*-
"""
Copyright 2015 Soeren Mindorf <support@mit42.de> and Fabian Zoske <support@zoske.it>

This file is part of Download-Link.

Download-Link is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

Download-Link is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Download-Link. If not, see <http://www.gnu.org/licenses/>.
"""


import os
from app import babel, nav
from config import LANGUAGES
from flask import render_template, redirect, request, url_for, flash, current_app
from flask.ext.babel import gettext, lazy_gettext
from flask.ext.login import login_required
from flask_nav.elements import Navbar, View, Subgroup, Text
from sqlalchemy.exc import IntegrityError
from werkzeug.utils import secure_filename
from . import file
from .forms import FileEditForm, GenerateUid, UploadForm
from ..model import db, File, DownloadKey
from ..utils.helper import get_random_string


topbar = Navbar(
    View((lazy_gettext(u'Home')), 'file.management'),
    Subgroup(lazy_gettext(u'Maintenance'),
             Text('Database tasks'),
             View(lazy_gettext(u'Cleanup Database if file exist on filesystem'), 'maintenance.cleanup_file_in_db'),
             View(lazy_gettext(u'Delete files where lifetime is exceeded'), 'maintenance.cleanup_file_lifetime')),
    Subgroup(lazy_gettext(u'Your Account'),
             View(lazy_gettext(u'Change Password'), 'user.change_password'),
             View(lazy_gettext(u'Logout'), 'auth.logout')),
    Subgroup(lazy_gettext(u'About'),
             View(lazy_gettext(u'Impress'), 'main.about'),
             View(lazy_gettext(u'License'), 'main.license')),
    View((lazy_gettext(u'Help')), 'main.help')
)

nav.register_element('top', topbar)


def allowed_file(filename):
    return '.' in filename and \
           filename.rsplit('.', 1)[1] in current_app.config['ALLOWED_EXTENSIONS']


@babel.localeselector
def get_locale():
    return request.accept_languages.best_match(LANGUAGES.keys())


@file.route('/management', methods=['GET', 'POST'])
@file.route('/management/<int:page>', methods=['GET', 'POST'])
@login_required
def management(page=1):
    form = UploadForm(request.form)
    form_uid = GenerateUid()
    form_edit = FileEditForm()
    get_files = File.query.order_by(File.id)
    files = get_files.paginate(page, current_app.config['IDS_PER_PAGE'], False)
    return render_template('file/filemanager.html', files=files, form=form, form_uid=form_uid, form_edit=form_edit,
                           title=gettext(u'Filemanager'))


@file.route('/<int:file_id>/gen_uid', methods=['GET', 'POST'])
@login_required
def gen_uid(file_id):
    form = GenerateUid()
    if form.validate_on_submit():
        db_file = File.query.get_or_404(file_id)
        max_downloads, genuniqueids, lifetime = (form.max_downloads.data, form.genuniqueids.data, form.lifetime.data)
        if not lifetime:
            lifetime = 10
        if lifetime < 1 or lifetime > 120:
            flash(gettext(u'Please enter a number between 1 and 120!'))
            return redirect(url_for('file.management'))
        show_key = []
        for _ in range(0, genuniqueids):
            key = DownloadKey(download_key=get_random_string(), filename_id=file_id, maxdownloads=max_downloads,
                           lifetime=lifetime)
            upd_file = File.query.filter_by(id=file_id).first()
            upd_file.lifetime = lifetime
            db.session.add(key)
            try:
                db.session.commit()
            except IntegrityError:
                db.session.rollback()
            show_key.append(key)
        host = request.host_url
        return render_template('file/show_uids.html', form=form, uids=show_key, file=db_file, host=host,
                               title=gettext(u'Unique IDs'))
    flash(gettext(u'Your entry was not correct!'))
    return render_template("file/show_uids.html", form=form, title=gettext(u'Unique IDs'))


@file.route('/<int:file_id>/edit', methods=['GET', 'POST'])
@login_required
def edit(file_id):
    db_file = File.query.get_or_404(file_id)
    form = FileEditForm(obj=db_file)
    if form.validate_on_submit():
        db_file.note, db_file.downloadName, db_file.lifetime = (
            form.note.data, form.downloadName.data.replace(' ', '_'), form.lifetime.data)
        db.session.add(db_file)
        try:
            db.session.commit()
        except IntegrityError:
            db.session.rollback()
        flash(u'Database entry updated!')
        return redirect(url_for('file.management'))
    return render_template('file/upload.html', form=form)


@file.route('/<int:file_id>/delete')
@login_required
def delete(file_id):
    db_file = File.query.get_or_404(file_id)
    fs_file = os.path.join(current_app.config['UPLOAD_FOLDER'], db_file.filename)
    if os.path.exists(current_app.config['UPLOAD_FOLDER']):
        if os.path.isfile(fs_file):
            db.session.delete(db_file)
            os.remove(fs_file)
            try:
                db.session.commit()
            except IntegrityError:
                db.session.rollback()
            flash(gettext(u'File deleted: ') + db_file.filename)
        else:
            flash(gettext(u'File not found!'))
    return redirect(url_for('file.management'))


@file.route('/upload', methods=['GET', 'POST'])
@login_required
def upload():
    form = UploadForm(request.form)
    if form.validate_on_submit():
        filename, note, download_name, lifetime = (form.filename.data, form.note.data, form.download_name.data,
                                                   form.lifetime.data)
        file = request.files['filename']
        if file and allowed_file(file.filename):
            filename = secure_filename(file.filename)
            if not os.path.isfile(os.path.join(current_app.config['UPLOAD_FOLDER'], filename)):
                with open(os.path.join(current_app.config['UPLOAD_FOLDER'], filename), 'wb+') as dest:
                    for chunk in filename.chunks():
                        dest.write(chunk)
                # file.save(os.path.join(current_app.config['UPLOAD_FOLDER'], filename))
                if not download_name:
                    download_name = filename
                download_name.replace(' ', '_')
                ins_files = File(downloadName=download_name, note=note, filename=filename, lifetime=lifetime)
                db.session.add(ins_files)
                try:
                    db.session.commit()
                except IntegrityError:
                    db.session.rollback()
            else:
                flash(gettext(u'File already exists!'))
            return redirect(url_for('file.management', filename=filename))
        else:
            flash(gettext(u'Your filename extension is not allowed!'))
            return redirect(url_for('file.management'))
    return render_template('file/upload.html', form=form, title=gettext(u'Edit'))


@file.route('/show_uploads', methods=['GET', 'POST'])
@file.route('/<int:file_id>/show_uploads', methods=['GET', 'POST'])
@file.route('/<int:file_id>/show_uploads/<int:page>', methods=['GET', 'POST'])
@login_required
def show_uploads(file_id=0, page=1):
    if request.method == 'POST':
        if request.form['action'] == 'delete_entry':
            entry = DownloadKey.query.filter_by(download_key=request.form['id']).first()
            db.session.delete(entry)
            try:
                db.session.commit()
            except IntegrityError:
                db.session.rollback()
            flash(gettext(u'Database entry deleted: ') + request.form['id'])
            return redirect(url_for('file.show_uploads', file_id=entry.filename_id))
        return redirect(url_for('file.show_uploads'))
    entry1 = DownloadKey.query.filter_by(filename_id=file_id)
    unique_keys = entry1.paginate(page, current_app.config['IDS_PER_PAGE'], False)
    host = request.host_url
    return render_template('file/show_entries.html', download_keys=unique_keys, f_id=file_id,
                           title=gettext(u'Uploaded files'), host=host)

app/templates/file/filemanager.html
{% extends "layout.html" %}
{% import "bootstrap/wtf.html" as wtf %}
{% block title %}{{ title }}{% endblock %}
{% block head %}
	{{ super() }}
	<style>
		body {
			font-size: 16px;
		}
	</style>
{% endblock %}
{% block content %}
	<h1 class="text-center">{{ title }} - MIT42 DownloadLink</h1>
	{% if files %}
		<div class="table-responsive">
			<table class="table">
				<tr>
					<th>{{ _('id') }}</th>
					<th>{{ _('Filename') }}</th>
					<th>{{ _('Note') }}</th>
					<th>{{ _('Downloadname') }}</th>
					<th>{{ _('Save date') }}</th>
					<th>{{ _('Lifetime (in days)') }}</th>
					<th>{{ _('Action') }}</th>

				</tr>
				{% for row in files.items %}
					<tr>
						<td>{{ row.id }}</td>
						<td>{{ row.filename }}</td>
						<td>{{ row.note }}</td>
						<td>{{ row.downloadName }}</td>
						<td>{{ row.uploaddate }}</td>
						<td>{{ row.lifetime }}</td>
						<td>
							<button onclick="modal_uid('{{ row.id }}')" type="button" class="btn btn-primary btn-xs"
									data-toggle="modal"
									data-target="#genUIDUpload" data-backdrop="static" title="{{ _('generate ids') }}">
								<span class="fa fa-plus" aria-hidden="true"></span>
							</button>
							<button onclick="modal_edit_uid('{{ row.id }}', '{{ row.downloadName }}', '{{ row.note }}')"
									type="button" class="btn btn-primary btn-xs" data-toggle="modal" data-target="#fileEdit"
									data-backdrop="static" title="{{ _('edit') }}">
								<span class="fa fa-pencil-square-o" aria-hidden="true"></span>
							</button>
							<a href="{{ url_for("file.delete", file_id=row.id) }}" class="btn-xs btn btn-danger"
							   title="{{ _('delete') }}">
								<span class="glyphicon glyphicon-trash" aria-hidden="true"></span>
							</a>
							<a href="{{ url_for("file.show_uploads", file_id=row.id) }}" class="btn-xs btn btn-info"
							   title="{{ _('show ids') }}">
								<span class="fa fa-info-circle" aria-hidden="true"></span>
							</a>
						</td>
					</tr>
				{% endfor %}
			</table>
		</div>
	{% else %}
		<div class="container">
			<h2 class="text-danger text-center ">{{ _('No entries found') }}</h2>
		</div>
	{% endif %}
	<div class="text-right">
		{% if files.has_prev %}
			<a href="{{ url_for('file.management', file_id=f_id, page=files.prev_num) }}">
				&lt;&lt; {{ _('one page back') }}
			</a>|
		{% endif %}
		{% if files.has_next %}
			<a href="{{ url_for('file.management', file_id=f_id, page=files.next_num) }}">
				{{ _('next page') }} &gt;&gt;
			</a>
		{% endif %}
	</div>
	<br/>

	<br/>
	<div class="col-md-6">
		<!-- modal Upload-->
		<!-- Button trigger modal -->
		<button type="button" class="btn btn-success btn-lg pull-right " data-toggle="modal"
				data-target="#myModalUpload" data-backdrop="static" title="{{ _('upload file') }}">
			<span class="glyphicon glyphicon-upload" aria-hidden="true">{{ _(' Upload') }}</span>
		</button>

	</div>
	<br/>
	<br/>
	<br/>
	<div class="row small">
        <h1 class="text-center">{{ _("Legend") }}</h1>
		<div class="col-md-6" id="legend">
			<p><span class="fa fa-plus btn-primary btn btn-xs"
					 aria-hidden="true"></span>&nbsp; {{ _('Generate Downloadkeys') }}</p>

			<p><span class="fa fa-pencil-square-o btn btn-primary btn-xs" aria-hidden="true"></span>&nbsp; {{ _('Edit') }}</p>
		</div>
		<div class="col-md-2 col-md-offset-4" id="legend">
			<p><span class="glyphicon glyphicon-trash btn btn-xs btn-danger"
					 aria-hidden="true"></span>&nbsp; {{ _('Delete') }}</p>

			<p><span class="fa fa-info-circle btn btn-xs btn-info"
					 aria-hidden="true"></span>&nbsp; {{ _('Show Downloadkeys') }}</p>
		</div>
	</div>
	<!-- Modal Gernerate UID-->
	<div class="modal fade" id="genUIDUpload" tabindex="-1" role="dialog"
		 aria-labelledby="genUIDUploadLabel">
		<div class="modal-dialog" role="document">
			<div class="modal-content">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span
							aria-hidden="true">&times;</span></button>
					<h4 class="modal-title" id="genUIDUploadLabel">{{ _('Generate Downloadkeys') }}</h4>
				</div>
				<div class="modal-body">
					{{ wtf.quick_form(form_uid, button_map={'submit':'success'}, action=url_for("file.gen_uid", file_id="-1"), id="form_gen_uid") }}
				</div>
			</div>
		</div>
	</div>
	<!-- modal Generate UID Ende -->
	<!-- Modal Upload -->
	<div class="modal fade" id="myModalUpload" tabindex="-1" role="dialog" aria-labelledby="myModalUploadLabel">
		<div class="modal-dialog" role="document">
			<div class="modal-content">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal" aria-label="Close">
						<span aria-hidden="true">&times;</span>
					</button>
					<h4 class="modal-title" id="myModalUploadLabel">{{ _('Upload file') }}</h4>
				</div>
				<div class="modal-body">
					{{ wtf.quick_form(form, button_map={'submit':'success'}, action=url_for("file.upload"), enctype="multipart/form-data") }}
				</div>

			</div>
		</div>
	</div>
	<!-- modal Upload Ende -->

	<!-- Modal Edit Start-->
	<div class="modal fade" id="fileEdit" tabindex="-1" role="dialog"
		 aria-labelledby="fileEditLabel">
		<div class="modal-dialog" role="document">
			<div class="modal-content">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span
							aria-hidden="true">&times;</span></button>
					<h4 class="modal-title" id="fileEditLabel">{{ _('Edit') }} </h4>
				</div>
				<div class="modal-body">
					{{ wtf.quick_form(form_edit, button_map={'submit':'success'}, action=url_for("file.edit", file_id="-2"), id="form_edit") }}
				</div>

			</div>
		</div>
	</div>
	<!-- modal Edit Ende -->


	<script type="text/javascript">
		const gen_uid_base_url = "{{ url_for("file.gen_uid", file_id="-1") }}";
		const edit_base_url = "{{ url_for("file.edit", file_id="-2") }}";

		function modal_uid(id) {
			var form = $('#form_gen_uid');
			form.attr('action', gen_uid_base_url.replace("-1", id));
		}
		function modal_edit_uid(id, name, note) {
			var form = $('#form_edit');
			form.attr('action', edit_base_url.replace("-2", id));
			form.find('#downloadName').val(name);
			form.find('#note').val(note);
		}
	</script>
{% endblock %}

app/templates/file/show_entries.html
{% extends "layout.html" %}
{% block title %}{{ title }}{% endblock %}
{% block content %}

	<h1 class="text-center">{{ title }} - MIT42 DownloadLink</h1>
	{% if download_keys.total %}
		<div class="table-responsive ">
			<table class="table entry-link">
				<tr>
					<th>{{ _('Downloadkey') }}</th>
					<th>{{ _('Maxdownloads') }}</th>
					<th>{{ _('Downloads') }}</th>
					<th>{{ _('Download-Name') }}</th>
					<th>{{ _('Filename') }}</th>
					<th></th>
				</tr>
				{% for row in download_keys.items %}
					<tr>
						<td><a href="{{ host + 'key/' + row.download_key }}">{{ host + 'key/' + row.download_key }}</a></td>
						<td>{{ row.maxdownloads }}</td>
						<td>{{ row.downloads }}</td>
						<td>{{ row.file.downloadName }}</td>
						<td>{{ row.file.filename }}</td>

						<td>
							<a class="btn btn-sm btn-danger"
							   href="{{ url_for('key.delete_key', key_id=row.id) }}"
							   type="submit" name='action' title="{{ _('delete') }}">
								<span class="glyphicon glyphicon-trash" aria-hidden="true"></span>
							</a>
						</td>
					</tr>
				{% endfor %}

			</table>
		</div>
	{% else %}
		<div class="container">
			<h2 class="text-danger text-center ">{{ _('unable to found free Unique IDs for the file') }}</h2>
		</div>
	{% endif %}
	<div class="text-right">
		{% if download_keys.has_prev %}
			<a href="{{ url_for('file.show_uploads', file_id=f_id, page=download_keys.prev_num) }}">
				&lt;&lt; {{ _('one page back') }}
			</a>|
		{% endif %}
		{% if download_keys.has_next %}
			<a href="{{ url_for('file.show_uploads', file_id=f_id, page=download_keys.next_num) }}">
				{{ _('next page') }} &gt;&gt;
			</a>
		{% endif %}
	</div>
	<div class="text-center">
		<br/>
		<a href="{{ url_for('file.management') }}">{{ _('Back') }}</a>
	</div>
{% endblock %}

app/templates/file/show_uids.html
{% extends "layout.html" %}
{% import "bootstrap/wtf.html" as wtf %}
{% block title %}{{ title }}{% endblock %}
{% block content %}
	<h1>{{ title }} - MIT42 DownloadLink</h1>
	{% if uids %}
		<div class="table-responsive">
			<table class="table entry-link">
				<tr>
					<th>{{ file.downloadName }}</th>
				</tr>
				{% for uid in uids %}
					<tr>
						<td><a href="{{ host + "key/" + uid.download_key }}">{{ host + "key/" + uid.download_key }}</a></td>
					</tr>
				{% endfor %}
			</table>
		</div>

	{% endif %}
	<a class='btn btn-info btn-sm' href="{{ url_for("file.management") }}">
		<span class="glyphicon glyphicon-arrow-left" aria-hidden="true"><br/> {{ _('Back') }}</span>
	</a>
{% endblock %}

app/templates/file/upload.html
{% extends "layout.html" %}
{% block title %}{{ title }}{% endblock %}
{% block content %}
	{% import "bootstrap/wtf.html" as wtf %}
	<h1 class="text-center">{{ title }} - MIT42 DownloadLink</h1>
	<br>

	<div class="row">
		<div class="col-md-4">
			{{ wtf.quick_form(form, button_map={'submit':'success'}) }}
		</div>
	</div>
	<br>
	<br>
	<a href="{{ url_for("main.menu") }}">{{ _('Back') }}</a>

{% endblock %}